/*
 * Created on Feb 2, 2006
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.client;


import org.ggf.schemas.jsdl._2005._11.jsdl.JobDefinition_Type;

import org.nordugrid.job.gridftp.ARCGridFTPJob;
import org.globus.gsi.GlobusCredential;

/**
 * @author tordsson
 *
 *	Resolves where to stage locally stored input files to a submitted
 *  ARC job. 
 */
public class ARCClientJobStaging implements ClientJobStaging {

	/**
	 * In ARC, the job id is the directory in which to stage the input files 
	 * e.g. gsiftp://ingrid.hpc2n.umu.se:2811/jobs/692411388920582118393766
	 * @param jobid
	 * @param jobDesc
	 * @return
	 * @throws Exception
	 */
	public String getJobDirectory(String jobid, JobDefinition_Type jobDesc) 
	throws Exception {
		
		System.out.println("Getting job directory (ARC)"); 
		// Need to ensure that jobid follows the correct format. 
		// That is, it matches "gsiftp://.*:2811/jobs.*"
		if(jobid.matches("gsiftp://.*:2811/jobs.*")) {
			return jobid; 	
		}
		else {
			throw new Exception("Wrong format for jobid"); 
		}
	}
	
	/**
	 * Cancel job using jarclib
	 * @param jobID
	 * @throws Exception
	 */
	public void cancelJob(String jobID) throws Exception {
		
		// jobID has format gsiftp://host:2811/jobs/ID 
		// split this in gsiftp://host:2811/jobs and ID 
		int index = jobID.lastIndexOf('/'); 
		String hostURL = jobID.substring(0, index); 
		String id = jobID.substring(index + 1); 
		ARCGridFTPJob job = new ARCGridFTPJob(hostURL, id); 
		GlobusCredential credential = GlobusCredential.getDefaultCredential(); 
		job.addProxy(credential); 
		job.Connect(); 
		job.Cancel(); 
		job.Clean(); // ensures that any already uploaded files are removed. 
		job.Disconnect(); 
	}
	
}
