/*
 * Created on Apr 21, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.wsag.client;

import java.io.FileInputStream;
import java.util.Calendar;

import org.apache.axis.message.MessageElement;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.NCName;
import org.ggf.ws_agreement.Agreement;
import org.ggf.ws_agreement.AgreementServiceAddressingLocator;
import org.ggf.ws_agreement.TermTreeType;
import org.globus.axis.util.Util;
import org.globus.wsrf.WSRFConstants;
import org.globus.wsrf.encoding.ObjectDeserializer;
import org.oasis.wsrf.properties.GetResourcePropertyResponse;
import org.xml.sax.InputSource;

import se.umu.wsag.impl.AgreementConstants;
import se.umu.reservation.ReservationType;

/**
 * @author tordsson
 *
 * Client for getting RPs from an agreement (reservation) - test purposes only 
 */
public class QueryClient {
	
	static {
		Util.registerTransport(); 
	}

	public static void main(String[] args) {

		try {
        if(args.length < 1) {
            System.err.println("Usage: ReservationCancel eprFile");
            System.exit(1); 
        }

        AgreementServiceAddressingLocator locator = 
        	new AgreementServiceAddressingLocator(); 
        //ReservationServiceAddressingLocator locator = 
          //  new ReservationServiceAddressingLocator(); 
        
        String eprFileName = args[0]; 

        // Get EPR from file
        FileInputStream fileInputStream = new FileInputStream(eprFileName); 
        EndpointReferenceType epr = (EndpointReferenceType)
            ObjectDeserializer.deserialize( 
                    new InputSource(fileInputStream), 
                    EndpointReferenceType.class); 
        fileInputStream.close();
                
        Agreement agreement = locator.getAgreementPort(epr);
        
        // Get name of Agreement
        GetResourcePropertyResponse nameResponse = agreement.
			getResourceProperty(AgreementConstants.NAME_RP); 
        MessageElement any[] = nameResponse.get_any(); 
        NCName name = (NCName) ObjectDeserializer.toObject(any[0], 
        		NCName.class); 
        
        // Get terms:  
        GetResourcePropertyResponse termsResponse = 
        	agreement.getResourceProperty(AgreementConstants.TERMS_RP); 
        any = termsResponse.get_any();
        
        // 1: Extract TermTree        
        TermTreeType terms = (TermTreeType) ObjectDeserializer.toObject(
        		any[0], TermTreeType.class); 
        
        System.out.println("terms: " + terms); 
        
        // Is this a 2-step deser? -> Si si
        
        any = terms.getAll().getServiceDescriptionTerm().get_any();         
        ReservationType reservationInfo = (ReservationType) ObjectDeserializer.
			toObject(any[0], ReservationType.class); 
  
        System.out.println("Reservation:"); 
        System.out.println(reservationInfo.getLocalID()); 
        
        GetResourcePropertyResponse termTimeResponse = 
        	agreement.getResourceProperty(WSRFConstants.TERMINATION_TIME); 
        
        any = termTimeResponse.get_any();
        
        Calendar cal = (Calendar) ObjectDeserializer.toObject(any[0], 
        		Calendar.class);
        System.out.println("Resource will terminate: " + cal.getTime());                 
        
		} catch (Exception e) {
			System.err.println("Error!"); 
			e.printStackTrace(); 
		}
	
	
	}
}
